#include "AutoCriticalSection.h"
#include "SyncCriticalSection.h"

namespace sync
{

// class CAutoCriticalSection

CAutoCriticalSection::CAutoCriticalSection(CCriticalSection& section)
: _section(section)
{
   _section.enter();
}

CAutoCriticalSection::~CAutoCriticalSection() throw()
{
   _section.leave();
}

} // namespace sync