#ifndef __AUTO_CRITICAL_SECTION_H_INCLUDED__
#define __AUTO_CRITICAL_SECTION_H_INCLUDED__

namespace sync
{

class CCriticalSection;

class CAutoCriticalSection
{
public:
   CAutoCriticalSection(CCriticalSection& section);
   ~CAutoCriticalSection() throw();

private:
   CAutoCriticalSection(const CAutoCriticalSection& section);
   CAutoCriticalSection& operator=(const CAutoCriticalSection& section);

   CCriticalSection& _section;
}; // class CAutoCriticalSection

} // namespace sync

#endif // __AUTO_CRITICAL_SECTION_H_INCLUDED__