#include "ImplCriticalSection.h"

namespace sync
{

CCriticalSection::CCriticalSectionImpl::CCriticalSectionImpl()
{
   ::InitializeCriticalSection(&_criticalSection);
}

CCriticalSection::CCriticalSectionImpl::~CCriticalSectionImpl()
{
   ::DeleteCriticalSection(&_criticalSection);
}

void CCriticalSection::CCriticalSectionImpl::enter()
{
   ::EnterCriticalSection(&_criticalSection);
}

void CCriticalSection::CCriticalSectionImpl::leave()
{
   ::LeaveCriticalSection(&_criticalSection);
}

bool CCriticalSection::CCriticalSectionImpl::tryEnter()
{
   return (::TryEnterCriticalSection(&_criticalSection) != 0);
}

} // namespace sync