#ifndef __IMPL_CRITICAL_SECTION_H_INCLUDED__
#define __IMPL_CRITICAL_SECTION_H_INCLUDED__

#include "SyncCriticalSection.h"
#include "SystemSync.h"

namespace sync
{

class CCriticalSection::CCriticalSectionImpl
{
public:
   CCriticalSectionImpl();
   ~CCriticalSectionImpl() throw();

   void enter();
   void leave();
   bool tryEnter();

private:
   CCriticalSectionImpl(const CCriticalSectionImpl&);
   CCriticalSectionImpl& operator=(const CCriticalSectionImpl&);

   CRITICAL_SECTION _criticalSection;
}; // class CCriticalSection::CCriticalSectionImpl

} // namespace sync

#endif // __IMPL_CRITICAL_SECTION_H_INCLUDED__